

import os
import fnmatch
import sys
import json
import time

import thread
import commands


def create_folder(directory):
    if not os.path.exists(directory):
        os.makedirs(directory)

def run_jidoshaserver(cfg):

    cmd = '%s --ini=%s'%(cfg['bin'], cfg['ini'])

    ## muda diretorio para o de execucao
    create_folder(cfg['exec_dir'])
    os.chdir(cfg['exec_dir'])

    os.environ['LD_LIBRARY_PATH'] = '%s'%cfg['libs_dir']

    os.environ['JL_LOGCFG'] = '%s'%cfg['log_conf']

    try:
        exec_cmd = ''
        if ('save_coredump' in cfg):
            if(cfg['save_coredump']):
                exec_cmd += 'ulimit -c unlimited; '
        exec_cmd += cmd
        commands.getoutput(exec_cmd)
    except:
        pass

    if ('save_coredump' in cfg):
        if(cfg['save_coredump']) :
            time.sleep(2)

            import traceback
            print "Exception in user code:"
            print '-'*60
            traceback.print_exc(file=sys.stdout)
            print '-'*60

            old_name = os.path.join(cfg['exec_dir'], 'core')
            new_name = os.path.join(cfg['logs_dir'], '%s.core'%time.strftime('%Y%m%d_%H%M%S'))
            commands.getoutput('mv -v %s %s'%(old_name, new_name))
    sys.exit(0)

def check_core_dumps(cfg): 

    num_files = len(fnmatch.filter(os.listdir(cfg['logs_dir']),'*.core'))

    if(num_files > 3):
        files_to_remove = num_files - 3
        cmd = 'ls %s/*.core | tail -%d | xargs rm -r'%(cfg['logs_dir'], files_to_remove)
        try:
            commands.getoutput(cmd)
        except:
            pass

def main():
    ## default configurations
    cfg = {
        "exec_dir": "/opt/jidoshaserver",
        "bin": "/opt/jidoshaserver/jidoshaserver",
        "libs_dir": "/opt/jidoshaserver",
        "ini": "/opt/jidoshaserver/jidosha.ini",
        "log_conf": "/opt/jidoshaserver/dconf.jlog",
        "save_coredump": False,
        "logs_dir": "/opt/jidoshaserver/logs"
    }
    if ('save_coredump' in cfg):
        if(cfg['save_coredump']):
            ## check the number of core dumps
            check_core_dumps(cfg)
    ## run the gateway service
    run_jidoshaserver(cfg)

if __name__ == '__main__':
    main()
